/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
feedTitleMaxLen = 44;

function wlCommonInit() {
	init();
}

function init() {
	// initialize the busy indicator
	initializeBusy();
	busy.show();
	// Show tabs only after application successfully initializes
	$('.tab').removeClass('hidden');
	// Set observers
	setObservers();
	// Load data
	loadFeeds();
	// Select the feed tab
	selectTab(FEEDS_TAB);

	initializeTabs();
	initializeMenu();
}

//Overrides common initializeBusy()
function initializeBusy() {
	busy = new WL.BusyIndicator('content');
}

function initializeTabs() {
	WL.TabBar.setParentDivId('tabBar');
	WL.TabBar.init();
	WL.TabBar.addItem('tab2', function () {selectTab('#feedsWrapper');}, Messages.tabFeed, {image : 'images/feed.png', imageSelected : 'images/feed.png'});
	WL.TabBar.addItem('tab1', function () {selectTab('#aboutTab');}, Messages.aboutTabTitle, {image : 'images/about.png', imageSelected : 'images/about.png'});
}

function initializeMenu() {
	WL.OptionsMenu.init();
	WL.OptionsMenu.addItem('reload', function () {loadFeeds();}, 'Reload', {image : 'reload', enabled : true});
}

//Overrides common displayFeedDescriptionTab()	
function displayFeedDescriptionTab(item) {
	$('#description').html(item.description);

	var title = trimString(item.title, feedTitleMaxLen);
	$('#feedTitle').html(title);
	$('#feedPubDate').html(item.pubDate);
	$('#feedTitle').bind('click', function(){
		WL.App.openURL(item.link, '_blank');
	});
}

function displayAboutTab() {
	// set the height of the about tab to take 100% of the height of the screen. Can not be done in CSS.
	$('#about').css({height : screen.height - 200 + 'px'});
}

function backToFeeds() {
	selectTab(FEEDS_TAB);
}

function afterDisplayItems() {

}

// Extends common selectTab()
function afterSelectTab(tabId) {
	
	switch (tabId) {
	case FEEDS_TAB:
		WL.App.resetBackButton();
		break;
	case FEEDS_DESCRIPTION_TAB:
		WL.App.overrideBackButton(backToFeeds);		
		break;
	case ABOUT_TAB:
		WL.App.resetBackButton();
		break;
	}
}

function applyOrientationClass() {
	// by changing the orientation class (portrait/landscape) on 'content' we apply different css height attributes on the scrolling wrappers.
	//
	// NOTE: The Android WebView automatically scales the values in the css file depending on the device screen dimensions. That is why, to support multiple dimensioned devices (Nexus1, Galaxy), one should never use javascript to set the height of a DOM element.
	
	if (window.orientation === 0) {
		// portrait
		contentDiv.removeClass('landscape');
		contentDiv.addClass('portrait');
	} else {
		//landscape
		contentDiv.removeClass('portrait');
		contentDiv.addClass('landscape');
	}
}

function scrollingSetUp() {
	// moving the reload link outside from scrollable area to enable the iScroll to work properly.
	$('#reload').remove();
	$('#content').append($('<a/>', {'id' : 'reload', 'class' : 'translate'}));	
	// Initialize orientation change support
	applyOrientationClass();
}