/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
var MONTH_NAME = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
	itemPane,
	descriptionPane,
	scrollDistance = 0;

function afterInitEnv() {
	$('#aboutTab').hide();
	$('#scrollUp').bind('click', function(){		
		selectPreviousItem();
	});
	$('#scrollDown').bind('click', function(){
		selectNextItem();
	});
	$('#reloadButton').bind('click', function(){
		loadFeeds();
	});
	
	WL.TabBar.init();
	WL.TabBar.addItem("Feeds", function(){displayFeedsTab();}, "Feeds", {
		image: 'images/feed.png'
	});
	WL.TabBar.addItem("About", function(){displayAboutTab();}, "About", {
		image: 'images/about.png'
	});
	WL.TabBar.setSelectedItem("Feeds");
	WL.TabBar.setVisible(true);
	
	// Touch start
	$('#scrollUp').bind('touchstart', function(){
		buttonTouchStart($('#scrollUp'), 'scrollUpClicked');
	});
	$('#scrollDown').bind('touchstart', function(){
		buttonTouchStart($('#scrollDown'), 'scrollDownClicked');
	});
	$('#reload').bind('touchstart', function(){
		buttonTouchStart($('#reload'), 'reloadButtonClicked');
	});
	$('#scrollUp').bind('touchend', function(){
		buttonTouchEnd($('#scrollUp'), 'scrollUpClicked');
	});
	$('#scrollDown').bind('touchend', function(){
		buttonTouchEnd($('#scrollDown'), 'scrollDownClicked');
	});
	$('#reload').bind('touchend', function(){
		buttonTouchEnd($('#reload'), 'reloadButtonClicked');
	});
}

function orientationChanged() {
	WL.Logger.debug("orientation changed");
	setTimeout(function() {
		//itemPane.refresh();
		//descriptionPane.refresh();
		setScrollDistance();
	}, 500);
}

function setScrollDistance() {
	scrollDistance = (window.document.height < 1000) ? 300 : 430;
}

function buttonTouchStart(item, style) {
	item.addClass(style);
}

function buttonTouchEnd(item, style) {
	item.removeClass(style);
}

function selectTab(tabId, item, li) {
	if (li) {
		$('#itemsList li').removeClass('landscapeSelected');
		li.addClass('landscapeSelected');
	}
	switch (tabId) {
	case FEEDS_TAB:
		displayFeedsTab();
		break;
	case FEEDS_DESCRIPTION_TAB:
		displayFeedDescriptionTab(item);
		break;
	case ABOUT_TAB:
		displayAboutTab();
		break;
	}
}

function scrollFeeds(elementOffsetTop) {
	elementOffsetTop = (elementOffsetTop < 250) ?  0 : elementOffsetTop-=250;
	$('#feedsWrapper').animate({scrollTop:elementOffsetTop}, 200);
}

function selectPreviousItem() {
	var curSibling = $('#itemsList li.landscapeSelected');
	var previousSibling = curSibling.prev();
	scrollFeeds(previousSibling[0].offsetTop);
	previousSibling.click();
}

function selectNextItem() {
	var curSibling = $('#itemsList li.landscapeSelected');
	var nextSibling = curSibling.next();
	scrollFeeds(nextSibling[0].offsetTop);
	nextSibling.click();
}

function setObservers() {
	// Override common setObservers() to do nothing
	$('#aboutWorklightLink').click(function(){
		WL.App.openURL('http://www.worklight.com','_blank');
	});
}

function displayFeedDescriptionTab(item) {
	// Update the content
	$("#description").html(item.description + "<br /><br /><br />");
}

function initializeBusy() {
	busy = new WL.BusyIndicator('content');
}

function afterDisplayItems() {
	var now = new Date();
	var nowHours = now.getHours();
	var nowMinutes = now.getMinutes();
	if (nowHours < 10) {
		nowHours = "0" + nowHours;
	}
	if (nowMinutes < 10) {
		nowHours = "0" + nowMinutes;
	}
	var displayDate = MONTH_NAME[now.getMonth()] + " " + now.getDate() + ", " + now.getFullYear() + " " + nowHours + ":" + nowMinutes;
	$('#lastUpdatedText').html(Messages.updated + " " + displayDate);
	$('#feedsScroller').append("<br /><br />");
	
	var firstFeed = $('#itemsList li').first();
	if (firstFeed) {
		firstFeed.click();
	}
}

function displayFeedsTab() {
	$('#aboutTab').hide();
	$('#feedsTab').show();
	$('#feedDescriptionTab').show();
}

function displayAboutTab() {
	$('#feedsTab').hide();
	$('#feedDescriptionTab').hide();
	$('#aboutTab').show();
}