/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
feedTitleMaxLen = 36;
var myFeedsScroll,
	myDescriptionScroll,
	feedsTab,
	aboutTab,
	reloadTab;

function displayFeedsTab() {
	
	WL.TabBar.setSelectedItem('feeds');
	reloadTab.setEnabled(true);
	$('#feedTitleContainer').hide();
	$('#aboutTab').hide();
	$('#feedsWrapper').show();
	$('#feedDescriptionTab').hide();
	$('#about').hide();
}

function displayAboutTab() {
	reloadTab.setEnabled(false);
	WL.TabBar.setSelectedItem('about');
	$('#feedTitleContainer').hide();
	$('#aboutTab').show();
	$('#feedsWrapper').hide();
	$('#feedDescriptionTab').hide();
	$('#about').hide();
}


// used to add functionality after the common wlCommonInit functions
function scrollingSetUp() {
	// moving the reload link outside from scrollable area.
	$('#reload').remove();
	$('#content').append($('<a/>', {'id' : 'reload', 'class' : 'translate'}));
	if (WL.StaticAppProps.ENVIRONMENT != WL.Env.PREVIEW) {
		document.addEventListener('#touchmove', function(e){e.preventDefault();});
	}
}

function beforeInitEnv() {
	WL.TabBar.init();
	feedsTab = WL.TabBar.addItem('feeds', function(){displayFeedsTab();}, Messages.backLink, {image: 'images/feed.png'});
	aboutTab = WL.TabBar.addItem('about', function(){displayAboutTab();}, Messages.tabAbout, {image: 'images/about.png'});
	reloadTab = WL.TabBar.addItem('reload', function(){loadFeeds();}, Messages.reload, {image: 'images/reload.png'});
	WL.TabBar.setSelectedItem('feeds');
	WL.TabBar.setVisible(true);
}

function afterInitEnv(){
	$('#about').click(function(){
		selectTab(FEEDS_TAB);
	});
}

//Overrides common initializeBusy()
function initializeBusy() {
	busy = new WL.BusyIndicator('content');
}

// used to add functionality after the displayItems function
function afterDisplayItems() {
	WL.TabBar.setSelectedItem('feeds');
	selectTab(FEEDS_TAB);
}

// replace the common displayFeedDescriptionTab function
function displayFeedDescriptionTab(item) {
	$('#feedTitle').unbind('click');
	$('#feedTitleContainer').show();
	$("#description").html(item.description);
	var title = trimString(item.title, feedTitleMaxLen);
	$('#feedTitle').html(title);
	$('#feedPubDate').html(item.pubDate);
	$('#feedTitle').bind('click', function(){
		WL.App.openURL(item.link,'_blank');
	});
	$('#description a').attr("target", "_blank");
	
	$('#about').show();
}

//used to add functionality after the selectTab function
function afterSelectTab(tabId) {
	switch(tabId) {
	case FEEDS_TAB:
		reloadTab.setEnabled(true);
		WL.TabBar.setSelectedItem('feeds');
	break;
	case FEEDS_DESCRIPTION_TAB:
		reloadTab.setEnabled(false);
	break;
	case ABOUT_TAB:
		reloadTab.setEnabled(false);
		WL.TabBar.setSelectedItem('about');
	break;
	}
}